/*
 * Cosmos - an xscreensaver module.
 * Tom Campbell and Jim Tanner Oct 2000 <campbell@mindspring.com>
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The author
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the author be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 *
 * Portions of this software were inspired by the late Seumas MacNally.
 * http://www.gamedev.net/community/memorial/seumas/
 *
 * $Id: cosmos.h,v 1.3 2001/02/20 03:14:31 jtanner Exp $
 */


extern "C" {
#include "screenhack.h"
}

// Forward declaration
class CCosmos;

#ifndef __cosmos__
#define __cosmos__

#include "script.h"
#include "actor.h"
#include "cosmoscast.h"
#include <vector>

class CCosmos
{
 public:
        static CCosmos* GetInstance();
	void InitDisplay(Display *dpy,Window window);
	~CCosmos();
	void Run();
	void DrawLine(int x0, int y0, int x1, int y1, int color);
	// This should be returned by Method.. 
	int getWidth(void){ return width;}
	int getHeight(void){ return height;}
	int actorcount;
	int castcount;

 private:
	CCosmos();
	void MakeImage();
	void InitColors();
	void InitColors(unsigned int r,unsigned int b,unsigned int g);
	void CycleColor();
	void DrawScreen(unsigned char *buf);
	void BurnCatchall(int flame, int up);
	void Burn16(int flame, int up);
	void Burn32(int flame, int up);
	//void SetCustomPalette(int pal);
	void RandomPoint();
	void Sparkle();
	void CreateCasts();
	//void Particles();
	void Stars();
	void ShowFrame();
	void CreateActors();
	void UpdateActors();
	void ResetActors();
	void ResetCasts();
	void UpdateCasts();
	void SetPixel(int x,int y, int c);
	void DisplayImage();
	void GetXInfo(Display *disp, Window win);
	void GetScreenInfo(Display *disp, Window win);

	vector<CCast*> cast;


 private:
	static CCosmos* m_instance;
	int             width;  // The actual width of the XImage
	int             height; // The actual hight of the XImage
	XImage          *xim;
	XColor *colors;
	GC              gc;
	int use_shm;
	int grid_size;
	int ncolors;
	Colormap        colormap;
	Visual          *visual;
	Bool            shared;	Display         *display;
	Window          window;
	int             depth;
	int frameclock;
	XWindowAttributes xwa;
	unsigned int* fbuff; // Virtual array of pixels represented by colormap index. 
	int showstars;
	int showflame;
	int sparkle;
	int stars;
	int cyclecolor;
	int resetcount;
	int color; // Current hue
	int frame;
	//int actorcount;
	void (CCosmos:: *Burn)(int flame, int up);
/**/
};

#endif
