/*
 * Cosmos - an xscreensaver module.
 * Tom Campbell and Jim Tanner Oct 2000 <campbell@mindspring.com>
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation.
 *
 * This file is provided AS IS with no warranties of any kind.  The author
 * shall have no liability with respect to the infringement of copyrights,
 * trade secrets or any patents by this file or any part thereof.  In no
 * event will the author be liable for any lost revenue or profits or
 * other special, indirect and consequential damages.
 *
 * Portions of this software were inspired by the late Seumas MacNally.
 * http://www.gamedev.net/community/memorial/seumas/
 *
 * cosmoscast.cpp : Casts are simply groups of actors. Different casts can
 * have different scripts, giving us different concurrent on-screen events.
 *
 * $Id: cosmoscast.cpp,v 1.2 2001/02/14 05:32:50 jtanner Exp $
 */


extern "C" {
#include "screenhack.h"
}

#include "stream.h"

#include "cosmoscast.h"


CCast::CCast(CCosmos *cosmos,CScript *script)
{
	this->cosmos = cosmos;
	this->script=script;
	blastcount = random()%40 + 40;
	count = 0;
	//cout << "Blastcount-" << blastcount << endl;
	for (int i=0;i<cosmos->actorcount;i++) {
		actors.push_back(new CActor(cosmos,cosmos->getWidth()/2,cosmos->getHeight()/2,script));
		if (!i)
			actors[i]->SetLeader(NULL);
		else
			actors[i]->SetLeader(actors[0]);
	}
}

void CCast::Reset(CScript *script)
{
	this->script = script;
	int x=random()%cosmos->getWidth();
	int y=random()%cosmos->getHeight();
	for (int i=0;i < cosmos->actorcount;i++)
		actors[i]->Reset(x,y,script);
}

void CCast::Reset()
{
	//cout << "CCast::Reset()" << endl;
	int x=random()%cosmos->getWidth();
	int y=random()%cosmos->getHeight();
	for (int i=0;i < cosmos->actorcount;i++)
		actors[i]->Reset(x,y,script);
}


void CCast::Update()
{
	count ++;
#ifdef DEBUG
 	cout << script->ScriptType() << endl;
#endif
	script->Follow(this);
	// XXX this should probably be handled inside of the explode script
}

